Attribute VB_Name = "mdlClpbrdAPI"
Option Explicit

Private Declare Function OpenClipboard Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function CloseClipboard Lib "user32" () As Long
Private Declare Function SetClipboardData Lib "user32" (ByVal wFormat As Long, ByVal hMem As Long) As Long
Private Declare Function GetClipboardData Lib "user32" (ByVal wFormat As Long) As Long
Private Declare Function EmptyClipboard Lib "user32" () As Long

Private Declare Function GlobalSize Lib "kernel32" (ByVal hMem As Long) As Long
Private Declare Function GlobalAlloc Lib "kernel32" (ByVal wFlags As Long, ByVal dwBytes As Long) As Long
Private Declare Function GlobalLock Lib "kernel32" (ByVal hMem As Long) As Long
Private Declare Function GlobalUnlock Lib "kernel32" (ByVal hMem As Long) As Long
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)
Private Declare Function lstrcpy Lib "kernel32" (ByVal lpString1 As Any, ByVal lpString2 As Any) As Long

Private Const CF_TEXT = 1
Private hMemory As Long
Private lpMemory As Long
Private retval As Variant

Public Sub CopyTextToClipboard(ByVal sText As String)
  
  sText = sText & Chr(0)
  hMemory = GlobalAlloc(0, Len(sText) + 1)
  If hMemory <> 0 Then
    lpMemory = GlobalLock(hMemory)
    If lpMemory <> 0 Then
      CopyMemory ByVal lpMemory, ByVal sText, Len(sText) + 1
      retval = GlobalUnlock(hMemory)
      If OpenClipboard(0&) <> 0 Then
        If EmptyClipboard() <> 0 Then
          If SetClipboardData(CF_TEXT, hMemory) = 0 Then _
            MsgBox "   " & sText & "   ", vbCritical + vbOKOnly, "   "
        End If
        CloseClipboard
      End If 'OpenClipboard
    End If 'lpMemory
  End If 'hMemory
End Sub

Public Function GetTextFromClipboard() As String
  Dim nLen As Long
  Dim sClipString As String
  On Error GoTo GoOut
  If OpenClipboard(0&) <> 0 Then
    hMemory = GetClipboardData(CF_TEXT)
    If hMemory <> 0 Then
      nLen = GlobalSize(nLen)
      lpMemory = GlobalLock(hMemory)
      If lpMemory <> 0 Then
        sClipString = Space(nLen)
        retval = lstrcpy(sClipString, lpMemory)
        retval = GlobalUnlock(hMemory)
        
        sClipString = Mid(sClipString, 1, InStr(sClipString, Chr(0)) - 1)
      Else
        MsgBox "    GlobalLock.", vbInformation + vbOKOnly, "    "
        GoTo GoOut
      End If
    Else
      MsgBox "      .", vbInformation + vbOKOnly, "    "
      GoTo GoOut
    End If
  Else
    MsgBox "    .", vbInformation + vbOKOnly, "    "
    GoTo GoOut
  End If 'OpenClipboard
GoOut:
  CloseClipboard
  GetTextFromClipboard = sClipString
End Function
